#!/bin/awk
func usage()
{
  print "usage: awk -f thisfile psfile [-page num]";
  print "\"-page\"psե̾θ˻ꤷƲ";
}

BEGIN{
  if (ARGV[1] == "-help" || ARGV[1] == "-h" || ARGV[1] == "?") {usage(); exit;}
  PRINTLINE = 1;
  PAREN = 0;
  PRTPAGE = 1;
  if (ARGC > 2){
    for (i = 0; i < ARGC; i ++) {
      if ( ARGV[i] == "-page" ) {
	PRTPAGE = ARGV[i+1];
	ARGC -= 2;
      }
    }
  }

  printf "%!PS-Adobe-2.0\n%%%%DocumentPaperSizes: A4\n%%%%EndComments\n";
  print "/rf {rectfill} def";

  if (PAREN == 1){
    print "/m {moveto} def";
    print "/l {lineto} def";
  }
  print "%%Page: 1 1";
}

($1 ~ /^%%Page:/ && $2 == PRTPAGE),/%%EndPage$/{
  if ($0 ~/sc$/ || $0 ~ /SC$/){
    if ($1 == 1 && $2 == 1 && $3 == 1) PRINTLINE = 0;
    else {
      if ($1 != 0 || $2 != 0 || $3 != 0 ){
	print "%";
	PRINTLINE = 2;
      }
      PRINTLINE = 1;
    }
  }

  if (PRINTLINE != 0){
    if ($0 ~ /rf$/ ) {
      if ( NF == 5 ) {
	print;
      }else{
	print "Wrong number of arguments.";
      }
    }
    if (PAREN == 1){
      if ($NF == "m" || $NF == "l") {
	if ( NF == 3 ) print;
	else print "Wrong number of arguments.";
      }
    }
  }
}

END{
  if (ARGV[1] != "-help" && ARGV[1] != "-h" && ARGV[1] != "?"){
    if (PAREN == 1) print "stroke";
    print "%%EndPage";
    printf "showpage\nend\n";
  }
}
